DEFINE force_matching_signature="&&1"

DECLARE
  name varchar2(50);
  version varchar2(3);
BEGIN
  select regexp_replace(version,'\..*') into version from v$instance;

  if version = '10' then
    execute immediate 
      q'[alter session set events '5614566 trace name context forever']'; -- bug fix for 10.2.0.4 backport
  end if;

  for i in ( select address||','||hash_value  name
             from v$sqlarea 
             where force_matching_signature = &&force_matching_signature
           )
  LOOP
      sys.dbms_shared_pool.purge(i.name,'C',1);
  END LOOP;
END;
/


UNDEFINE sql_id
